



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[LeetCode] 4Sum II 四数之和之二</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[LeetCode] 4Sum II 四数之和之二</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 16:54:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Given four lists A, B, C, D of integer values, compute how many tuples&nbsp;<code>(i, j, k, l)</code>&nbsp;there are such that&nbsp;<code>A[i] + B[j] + C[k] + D[l]</code>&nbsp;is zero.</p>
<p>To make problem a bit easier, all A, B, C, D have same length of N where 0 &le; N &le; 500. All integers are in the range of -228&nbsp;to 228&nbsp;- 1 and the result is guaranteed to be at most 231&nbsp;- 1.</p>
<p>Example:</p>
<pre class="prettyprint linenums">Input:<br />
A = [ 1, 2]<br />
B = [-2,-1]<br />
C = [-1, 2]<br />
D = [ 0, 2]

Output:<br />
2

Explanation:<br />
The two tuples are:<br />
1. (0, 0, 0, 1) -&gt; A[0] + B[0] + C[0] + D[1] = 1 + (-2) + (-1) + 2 = 0<br />
2. (1, 1, 0, 0) -&gt; A[1] + B[1] + C[0] + D[0] = 2 + (-1) + (-1) + 0 = 0</pre>
<p>这道题是之前那道&nbsp;<a href="http://www.cnblogs.com/grandyang/p/4515925.html" rel="external nofollow noreferrer">4Sum</a>&nbsp;的延伸，让我们在四个数组中各取一个数字，使其和为0。那么坠傻的方法就是遍历所有的情况，时间复杂度为 O(n<sup>4</sup>)。但是既然&nbsp;<a href="http://www.cnblogs.com/grandyang/p/4130379.html" rel="external nofollow noreferrer">Two Sum</a>&nbsp;那道都能将时间复杂度缩小一倍，那么这道题使用 HashMap 是否也能将时间复杂度降到 O(n<sup>2</sup>) 呢？答案是肯定的，如果把A和B的两两之和都求出来，在 HashMap 中建立两数之和跟其出现次数之间的映射，那么再遍历C和D中任意两个数之和，只要看哈希表存不存在这两数之和的相反数就行了，参见代码如下：</p>
<p>解法一：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    int fourSumCount(vector&lt;int&gt;&amp; A, vector&lt;int&gt;&amp; B, vector&lt;int&gt;&amp; C, vector&lt;int&gt;&amp; D) {<br />
        int res = ;<br />
        unordered_map&lt;int, int&gt; m;<br />
        for (int i = ; i &lt; A.size(); ++i) {<br />
            for (int j = ; j &lt; B.size(); ++j) {<br />
                ++m[A[i] + B[j]];<br />
            }<br />
        }<br />
        for (int i = ; i &lt; C.size(); ++i) {<br />
            for (int j = ; j &lt; D.size(); ++j) {<br />
                int target = - * (C[i] + D[j]);<br />
                res += m[target];<br />
            }<br />
        }<br />
        return res;<br />
    }<br />
};</pre>
</div>
<p>下面这种方法用了两个 HashMap 分别记录 AB 和 CB 的两两之和出现次数，然后遍历其中一个 HashMap，并在另一个 HashMap 中找和的相反数出现的次数，参见代码如下：</p>
<p>解法二：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    int fourSumCount(vector&lt;int&gt;&amp; A, vector&lt;int&gt;&amp; B, vector&lt;int&gt;&amp; C, vector&lt;int&gt;&amp; D) {<br />
        int res = , n = A.size();<br />
        unordered_map&lt;int, int&gt; m1, m2;<br />
        for (int i = ; i &lt; n; ++i) {<br />
            for (int j = ; j &lt; n; ++j) {<br />
                ++m1[A[i] + B[j]];<br />
                ++m2[C[i] + D[j]];<br />
            }<br />
        }<br />
        for (auto a : m1) res += a.second * m2[-a.first];<br />
        return res;<br />
    }<br />
};</pre>
</div>
<p>类似题目：</p>
<p><a href="http://www.cnblogs.com/grandyang/p/4515925.html" rel="external nofollow noreferrer">4Sum</a></p>
<p>参考资料：</p>
<p><a href="https://leetcode.com/problems/4sum-ii/" rel="external nofollow noreferrer">https://leetcode.com/problems/4sum-ii/</a></p>
<p><a href="https://leetcode.com/problems/4sum-ii/discuss/93920/Clean-java-solution-O(n2)" rel="external nofollow noreferrer">https://leetcode.com/problems/4sum-ii/discuss/93920/Clean-java-solution-O(n2)</a></p>
<p><a href="https://leetcode.com/problems/4sum-ii/discuss/93925/Concise-C%2B%2B-11-code-beat-99.5" rel="external nofollow noreferrer">https://leetcode.com/problems/4sum-ii/discuss/93925/Concise-C%2B%2B-11-code-beat-99.5</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/4606334.html" rel="external nofollow noreferrer">LeetCode All in One 题目讲解汇总(持续更新中...)</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq15xy29.html">pyqt5 开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvm52yq.html">【树莓派】树莓派网络配置：静态IP、无线网络、服务等</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kw2wr8.html">JavaScript或jQuery模拟点击超链接和按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1kmgx9.html">团队作业（NABC的分析）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x7pdr9.html">MyBatis 入门到精通&lpar;三&rpar; 高级结果映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpzn19.html">学习Swift--属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeyp7j9.html">ES聚合实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z33g29.html">Android 源码编译环境搭建&lpar;64位Ubuntu&rpar;各种依赖包安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm22e49.html">docker 使用Data Volume 共享文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrj2e9.html">PLINQ的 ForAll 对比集合的ForEach</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge2jo08.html">ios 自动化构建 code-select&colon; error&colon; tool &amp;&num;39&semi;xcodebuild&amp;&num;39&semi; requires Xcode&comma; but active developer directory&period;&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grxrzq.html">使用synchronized同步，经典银行账户问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rmlgz8.html">SKU &colon; Stock Keeping Unit</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gxw3mq.html">Python全栈之路----常用模块----hashlib加密模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rjpe48.html">缺失dll的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r24r08.html">Nginx负载均衡中后端节点服务器健康检查的操作梳理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2lnpy9.html">Java中如何正确的将byte&lbrack;&rsqb;数组转化为String类型？</a>
		</li>
						<li><a href="https://www.batexi.com/a/93py6or8.html">DPI &lpar;Deep Packet Inspection&rpar; 深度包检测技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql157zx9.html">VS2013、VS2015中，新建项目没有看到解决方案的问题（已解决）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kgkelq.html">springboot面试专题及答案</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q75z19e.html">SparkStreaming实现Exactly-Once语义</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4ole8z.html">WebComponent魔法堂&colon;深究Custom Element 之 标准构建</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j3llq5.html">Asp&period;Net Core 项目实战之权限管理系统（6） 功能管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8evzx91.html">控制反转、依赖注入、Unity容器</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql6m1qo.html">sqlserver 乐观并发模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o74pqz.html">分布式任务&amp;amp&semi;分布式锁（li）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93xxvr9.html">Atittit&period;研发公司的组织架构与部门架构总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8okj4l9.html">dyld 加载 Mach-O</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4yz3nq.html">java 中抽象类和接口的五点区别？</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j01req.html">MVC View中获取action、controller、area名称</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
